import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.stream.IntStream;
import java.util.Arrays;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author lewin
 */
public class full_clear_strategy_lewin_brute {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        FullClearStrategyBrute solver = new FullClearStrategyBrute();
        solver.solve(1, in, out);
        out.close();
    }

    static class FullClearStrategyBrute {
        int n;
        int t;
        int ans;
        int[] x;
        int[] b;

        public void dfs(int idx) {
            if (idx == n) {
                int[] ts = new int[n];
                boolean[] seen = new boolean[n];
                int last = -1;
                boolean ok = true;
                for (int i = 1; ok && i <= t; i++) {
                    int csolve = -1;
                    for (int j = 0; j < n; j++) {
                        if (b[j] <= i && ts[j] < x[j]) {
                            csolve = j;
                            break;
                        }
                    }
                    if (csolve != -1) {
                        if (last != -1 && last != csolve && seen[csolve]) {
                            ok = false;
                        }
                        seen[csolve] = true;
                        last = csolve;
                        ts[csolve]++;
                    }
                }
                if (ok && AUtils.sum(x) == AUtils.sum(ts)) {
                    ans++;
                }
                return;
            }
            for (int solve = 1; solve <= t; solve++) {
                b[idx] = solve;
                dfs(idx + 1);
            }
        }

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            n = in.nextInt();
            t = in.nextInt();
            x = in.readIntArray(n);
            b = new int[n];
            dfs(0);
            out.println(ans);
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(int i) {
            writer.println(i);
        }

    }

    static class AUtils {
        public static int sum(int[] arr) {
            return Arrays.stream(arr).reduce(0, Integer::sum);
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int[] readIntArray(int tokens) {
            int[] ret = new int[tokens];
            for (int i = 0; i < tokens; i++) {
                ret[i] = nextInt();
            }
            return ret;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }
}

